/*
 * Em84Device.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include <vdr/plugin.h>
#include <vdr/device.h>
#include <vdr/osdbase.h>

#include "em84device.h"
//#include "em84osd.h" 

static const char *VERSION  = "0.0.1";
static const char *DESCRIPTION = "SigmaDesign EM847x Device";
static const char *MAINMENUENTRY  = "Em84";

// --- cPluginEm84 -----------------------------------------------
class cPluginEm84 : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginEm84(void);
  virtual ~cPluginEm84();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  };

cPluginEm84::cPluginEm84(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginEm84::~cPluginEm84()
{
  // Clean up after yourself!
}

const char *cPluginEm84::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return "no options avaiable, yet.\n";
}

bool cPluginEm84::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginEm84::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  printf("initializing Plugin\n");
  new cEm84Device();
  return true;
}

bool cPluginEm84::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginEm84::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginEm84::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return NULL;
}

cMenuSetupPage *cPluginEm84::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginEm84::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

VDRPLUGINCREATOR(cPluginEm84); // Don't touch this!

