/*
 * em84osd.c: Implementation of the SigmaDesign EM847x On Screen Display
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */
#ifndef __EM84OSD_H
#define __EM84OSD_H

#include <sys/mman.h>
#include <vdr/device.h>
#include <vdr/osdbase.h>
#include <vdr/tools.h>

#include "em847x.h"

class cWindowLayer {
  private:
    int left, top;
    int width, height;
  public:
    unsigned char *Bitmap;
    cWindowLayer(int X, int Y, int W, int H);
    ~cWindowLayer();
    int X(void) { return left; }
    int Y(void) { return top; }
    int W(void) { return width; }
    int H(void) { return height; }
    void Move(int x, int y);
    void Render(cWindow *Window);
    unsigned char Data(int x, int y);
    bool visible;
};

class cEm84Osd : public cOsdBase {
private:
  void FullOSDRefresh(void);
  int xOfs, yOfs;
  cEm847x *em847x;
  cWindowLayer *layer[MAXNUMWINDOWS];
  bool OSDpresent;
  bool modifiedWindow;
  uint64_t lastUpdate;
  unsigned char *osd;
protected:
  virtual bool OpenWindow(cWindow *Window);
  virtual void CommitWindow(cWindow *Window);
  virtual void ShowWindow(cWindow *Window);
  virtual void HideWindow(cWindow *Window, bool Hide);
  virtual void MoveWindow(cWindow *Window, int x, int y);
  virtual void CloseWindow(cWindow *Window);
public:
  cEm84Osd( int x, int y, cEm847x *Em847x);
  virtual ~cEm84Osd();
//  static void SetEm84Device(const cEm84Device *Em84Device);
 };

#endif //__EM84OSD_H
